import 'dart:ffi';

import 'package:unit_rc/UnitRCDartRuntime.dart';
import 'package:unit_rc/internal_type/InternalClassList.dart';

class InternalClassListCpp extends InternalClassList {
  @override
  int count() {
    return _native_count(toCpp());
  }
  static late final _native_count = unitRCLib.lookupFunction<
      Int64 Function(Pointer<Void>),
      int Function(Pointer<Void>)>("UnitRC_InternalClassListCpp_count");

  @override
  dynamic get(int index) {
    return null;
  }

  static Object createFuncDeclareCpp() {
    return InternalClassListCpp();
  }

  static final createFuncDeclareCppFP = Pointer.fromFunction<Handle Function()>(createFuncDeclareCpp);
  static final registerCreateFuncDeclareCppFP = unitRCLib.lookupFunction<
      Void Function(Pointer<NativeFunction<Handle Function()>>),
      void Function(Pointer<NativeFunction<Handle Function()>>)
  >("UnitRC_Register_InternalClassListCpp_createHandle");

  static void registerNativeMethods() {
    registerCreateFuncDeclareCppFP(createFuncDeclareCppFP);
  }
}